import textwrap
from unittest.mock import patch

import pytest
from src.backup_crm_csv_data_process import backup_crm_csv_data_process
from src.config.objects import TargetObject
from src.error.exceptions import FileUploadException
from src.system_var.constants import CSVBK_JP_NAME
from src.util.execute_datetime import ExecuteDateTime

from .test_utils.log_message import generate_log_message_tuple


class TestBackupCrmCsvDataProcess:

    @pytest.fixture
    def bucket_name(self):
        return 'test-backup-bucket'

    @pytest.fixture
    def prepare_bucket(self, s3_client, bucket_name):
        s3_client.create_bucket(Bucket=bucket_name)
        yield

    def test_run_process_success(self, s3_client, prepare_bucket, bucket_name, monkeypatch, caplog):
        """
        Cases:
            CSVバックアップ処理が正常終了し、期待通りの結果となること
        Arranges:
            - prepare_bucketフィクスチャで、CRM電文データをバックアップするためのモックバケットを作る
            - 作成したモックバケットを指すように環境変数を設定する
        Expects:
            - CSVバックアップファイルがバケットに配置される
            - CSVバックアップ処理の仕様に沿った正常系ログが出力されること(デバッグログは除く)
        """
        # Arrange
        csv_data = [
            ["Id", "AccountNumber", "LastModifiedDate", "LastModifiedById", "SystemModstamp", "IsDeleted"],
            ["TEST001", "test001", "2022-06-01 09:00:00", "1234567", "2022-06-01 09:00:00", 1],
            ["TEST002", "test002", "2022-06-01 09:00:00", "1234567", "2022-06-01 09:00:00", 0],
            ["TEST003", "test003", "2022-06-01 09:00:00", "1234567", "2022-06-01 09:00:00", 0]
        ]
        target_object_dict = {
            'object_name': 'Account',
            'columns': [
                'Id',
                'AccountNumber',
                'LastModifiedDate',
                'LastModifiedById',
                'SystemModstamp',
                'IsDeleted'
            ]
        }

        execute_datetime = ExecuteDateTime()
        target_object = TargetObject(target_object_dict, execute_datetime)

        # 環境変数を編集
        monkeypatch.setattr('src.aws.s3.CRM_BACKUP_BUCKET', bucket_name)
        monkeypatch.setattr('src.aws.s3.CRM_IMPORT_DATA_BACKUP_FOLDER', 'data_import')

        # Act
        backup_crm_csv_data_process(target_object, execute_datetime, csv_data)

        # Assert

        expect_csv_value = """\
            "Id","AccountNumber","LastModifiedDate","LastModifiedById","SystemModstamp","IsDeleted"\r\n\
            "TEST001","test001","2022-06-01 09:00:00","1234567","2022-06-01 09:00:00","1"\r\n\
            "TEST002","test002","2022-06-01 09:00:00","1234567","2022-06-01 09:00:00","0"\r\n\
            "TEST003","test003","2022-06-01 09:00:00","1234567","2022-06-01 09:00:00","0"\r\n\
        """
        expect_file_key = f'data_import/{execute_datetime.to_path()}/CRM_Account_{execute_datetime.format_date()}.csv'
        # ファイル確認
        actual = s3_client.get_object(
            Bucket=bucket_name,
            Key=expect_file_key)

        assert actual['Body'].read().decode('utf-8') == textwrap.dedent(expect_csv_value)

        # ログの確認
        assert generate_log_message_tuple(
            log_message=f'I-CSVBK-01 [Account] のCSVデータのバックアップ処理を開始します  ファイル名：[CRM_Account_{execute_datetime.format_date()}.csv]'
        ) in caplog.record_tuples
        assert generate_log_message_tuple(
            log_message='I-CSVBK-03 [Account] のCSVデータのバックアップ処理を終了します') in caplog.record_tuples

    def test_call_depended_modules(self):
        """
        Cases:
            CSVバックアップ処理内で依存しているモジュールが正しく呼ばれていること
        Arranges:
            - CSVバックアップ処理の依存モジュールをモック化する
        Expects:
            - 依存しているモジュールが正しく呼ばれている
        """

        # Arrange
        target_object_dict = {
            'object_name': 'Account',
            'columns': [
                'Id',
                'AccountNumber',
                'LastModifiedDate',
                'LastModifiedById',
                'SystemModstamp',
                'IsDeleted'
            ]
        }

        execute_datetime = ExecuteDateTime()
        target_object = TargetObject(target_object_dict, execute_datetime)

        with patch('src.backup_crm_csv_data_process.BackupBucket') as mock_backup_bucket, \
                patch('src.backup_crm_csv_data_process.CsvWriter') as mock_writer:
            mock_backup_bucket_inst = mock_backup_bucket.return_value
            mock_backup_bucket_inst.put_csv.return_value = ''

            mock_writer_inst = mock_writer.return_value
            mock_writer_inst.write.return_value = ''
            # Act
            backup_crm_csv_data_process(target_object, execute_datetime, '')

        # Assert

        assert mock_backup_bucket_inst.put_csv.called is True
        assert mock_writer_inst.write.called is True

    def test_raise_put_csv(self, bucket_name, monkeypatch, caplog):
        """
        Cases:
            CSVデータをバックアップできない場合、エラーが発生すること
        Arranges:
            - CSVデータをバックアップ処理で例外が発生するようにする
        Expects:
            - 例外が発生する
            - ファイル登録できないエラーが返却される
        """

        # Arrange
        target_object_dict = {
            'object_name': 'Account',
            'columns': [
                'Id',
                'AccountNumber',
                'LastModifiedDate',
                'LastModifiedById',
                'SystemModstamp',
                'IsDeleted'
            ]
        }

        execute_datetime = ExecuteDateTime()
        target_object = TargetObject(target_object_dict, execute_datetime)

        with patch('src.backup_crm_csv_data_process.BackupBucket') as mock_backup_bucket, \
                patch('src.backup_crm_csv_data_process.CsvWriter') as mock_writer:
            mock_backup_bucket_inst = mock_backup_bucket.return_value
            mock_backup_bucket_inst.put_csv.side_effect = Exception('登録エラー')

            mock_writer_inst = mock_writer.return_value
            mock_writer_inst.write.return_value = ''
            # Act
            with pytest.raises(FileUploadException) as e:
                backup_crm_csv_data_process(target_object, execute_datetime, '')

        # Assert

        assert mock_writer_inst.write.called is True
        assert mock_backup_bucket_inst.put_csv.called is True
        assert e.value.error_id == 'E-CSVBK-01'
        assert e.value.func_name == CSVBK_JP_NAME
        assert e.value.args[0] == \
            f'[Account] CSVデータのバックアップに失敗しました ファイル名：[CRM_Account_{execute_datetime.format_date()}.csv] エラー内容:[登録エラー]'

    def test_raise_put_csv_write_local_file(self, bucket_name, monkeypatch, caplog):
        """
        Cases:
            CSVデータをバックアップするための一時ファイルを書き込めない場合、エラーが発生すること
        Arranges:
            - オブジェクト情報ファイル取得処理で例外が発生するようにする
        Expects:
            - 例外が発生する
            - ファイルが書き込めないエラーが返却される
        """

        # Arrange
        target_object_dict = {
            'object_name': 'Account',
            'columns': [
                'Id',
                'AccountNumber',
                'LastModifiedDate',
                'LastModifiedById',
                'SystemModstamp',
                'IsDeleted'
            ]
        }

        execute_datetime = ExecuteDateTime()
        target_object = TargetObject(target_object_dict, execute_datetime)

        with patch('src.backup_crm_csv_data_process.BackupBucket') as mock_backup_bucket, \
                patch('src.backup_crm_csv_data_process.CsvWriter') as mock_writer:
            mock_backup_bucket_inst = mock_backup_bucket.return_value
            mock_backup_bucket_inst.put_csv.return_value = ''

            mock_writer_inst = mock_writer.return_value
            mock_writer_inst.write.side_effect = Exception('書き込みエラー')
            # Act
            with pytest.raises(FileUploadException) as e:
                backup_crm_csv_data_process(target_object, execute_datetime, '')

        # Assert

        assert mock_writer_inst.write.called is True
        assert mock_backup_bucket_inst.put_response_json.called is False
        assert e.value.error_id == 'E-CSVBK-01'
        assert e.value.func_name == CSVBK_JP_NAME
        assert e.value.args[0] == \
            f'[Account] CSVデータのバックアップに失敗しました ファイル名：[CRM_Account_{execute_datetime.format_date()}.csv] エラー内容:[書き込みエラー]'
